\ -------------------------------------------------------
\ Feillikningskoeffisientane bli plasserte i FE{, leddnr i IN{
\ Deretter blir normallikningskoeffisientar danna ved kryssmultiplisering
\ av FE{ og akkumulering i N1{
\ N1{ skal vera intakt, difor blir gauss utført på ein kopi

\ VARIABLE stal2			\ antal relevante sikt 
VARIABLE #obs			\ antall obs = antal feillikn
VARIABLE etal2			\ antal kolonnar (element+konstantledd)
VARIABLE Pvekt				\ vekt
VARIABLE krymping   
VARIABLE #alarmar
VARIABLE sumpvvi   \ feilkvadratsum intern (oppskalert)

1 CELLS  DUP * 64 SWAP /  ( 1|4 ) krymping !

\ Normallikningar  rå -----------------------------------------
INTEGER DMATRIX N1{{		\ normallikningar, rå
\ N1 er etal2*etal2, A er etal*etal !
\ reserver plass/frigjer plass
: +N1   ( n -- )	\ symmetrisk etal2*etal2 matrise
	& N1{{ SWAP DUP }}malloc  malloc-fail? ABORT" N1malloc failed" ;
: -N1  	& N1{{ }}free ;

: 0N1 ( - ) \ nullstill N1
	etal2 @ 0 DO 
		etal2 @ 0 DO
			0 N1{{ J I }} !
		LOOP
	LOOP ;

: 0NL ( n -- ) \ nullstill N1 mm
	TO #ko   \ antall koeff + konstantledd, x1 y1 x2 y2 o f
	0 #obs !     0N1   0 sumpvvi ! ; \ xyskala

: NLiknplass   ( -- )
    etal @ 1 + etal2 !	\ antal kolonnar inkl f
	etal2 @   +N1  ; 	\ plass for normallikningar
	
\ --------------------------------------------------------------

testing [IF]	\ for testing
: .nov ( - ) CR ." Normallikningar V+H i N1. Antall obs " #obs ?
	etal2 @ 0 DO CR ." |"
		etal2 @ 0 DO
			N1{{ J I }} @ 14 .R
		LOOP
	LOOP ;

: .N1h ( -- ) CR ." Normallikningar H " #obs ? 
	CR etal @ 0 DO
		N1{{ I etal2 @  }} @ 11 .R
	LOOP ;

: .fe2 ( -- ) \ ein f-likn - grunnlaget for akkumulering
	CR Pvekt @ 3 .R   
	#ko 0 DO             \ utan indeksar
		FE{ I } @ 12 .R		\ koeffisientar
	LOOP ;
[THEN]

