\ Vektorar for inndata: punkt og sikt

: use(  STATE @ IF POSTPONE ['] ELSE ' THEN ;  IMMEDIATE
: &     POSTPONE use( ; IMMEDIATE

0 VALUE siktmax                \ antal det er avsett plass for
0 VALUE pktmax
VARIABLE ptal               \ antal pkt
VARIABLE stal               \ antal sikt
Variable ptalauka           \ flag

\ Tabellar felles ---------------------------------

16 DARRAY SFRA{          \ fra-punkt
16 DARRAY STIL{          \ til-punkt

\ pekarar til pkt-tabell
INTEGER DARRAY SFRANR{
INTEGER DARRAY STILNR{
16 DARRAY P{
INTEGER   DARRAY opphav{
\ pekar til orienteringstabell
20 INTEGER ARRAY ORNR{

: frapkt ( snr - pnr ) SFRANR{ SWAP } @ ; 

: tilpkt ( snr - pnr ) STILNR{ SWAP } @ ;

: pktnamn!  ( a u - )
   P{ ptal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;            \ str>tabell

: frapkt!  ( a u - )
   SFRA{ stal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;            \ str>tabell

: tilpkt!  ( a u - )
   STIL{ stal @ } ( a1 u a2 )   DUP 16 BLANK
   SWAP CMOVE ;            \ str>tabell

DOUBLE DARRAY XY{
INTEGER DARRAY LS{          \ skrålengde obs
INTEGER DARRAY LSvekt{       \ på lengdeobs
INTEGER DARRAY VV{         \ vertikalvinkel obs
INTEGER DARRAY HV{         \ horisontalvinkel obs
INTEGER DARRAY HVvekt{      \ vekt hv
INTEGER DARRAY VVvekt{      \ vekt vv
INTEGER DARRAY H{           \ høgde
INTEGER DARRAY RV{           \ retningsvinkel
INTEGER DARRAY OV{           \ orienteringsvinkel
DOUBLE DARRAY IS{            \ instrh-sikteh vekt

: +SIKT   ( siktmax -- ) \ reservering av plass for sikt
    & SFRA{ OVER }malloc  malloc-fail? ABORT" 1malloc failed"
    & STIL{ OVER }malloc  malloc-fail? ABORT" 2malloc failed" 
    & LS{ OVER }malloc     malloc-fail? ABORT" 3malloc failed"
    & LSvekt{ OVER }malloc     malloc-fail? ABORT" 4malloc failed"
    & VV{ OVER }malloc     malloc-fail? ABORT" 7malloc failed"
	& HV{ OVER }malloc     malloc-fail? ABORT" 8malloc failed"
	& HVvekt{ OVER }malloc     malloc-fail? ABORT" 9malloc failed"
	& VVvekt{ OVER }malloc     malloc-fail? ABORT" vvv-malloc failed"
    & SFRANR{ OVER }malloc  malloc-fail? ABORT" 5malloc failed"
    & STILNR{ OVER }malloc  malloc-fail? ABORT" 6malloc failed"
    & RV{ OVER }malloc  malloc-fail? ABORT" RVmalloc failed" 
    & OV{ OVER }malloc  malloc-fail? ABORT" OVmalloc failed" 
	& IS{ OVER }malloc  malloc-fail? ABORT" ismalloc failed" 
	CR . ." plassar for sikt reservert" ;
    
 : +PKT   ( pktmax -- ) \ reservering av plass for pkt
    & P{ OVER }malloc  malloc-fail? ABORT" 7malloc failed"
	& XY{ OVER }malloc  malloc-fail? ABORT" xymalloc failed"
	& H{ OVER }malloc  malloc-fail? ABORT" hmalloc failed"
	& opphav{ OVER }malloc  malloc-fail? ABORT" 10malloc failed" 
	CR . ." plassar for punkt reservert" ;

: -SIKT
    & SFRA{ }free  & STIL{ }free  & LSvekt{ }free
    & SFRANR{ }free & STILNR{ }free 
	& HV{ }free & VV{ }free & LS{ }free & HVvekt{ }free 
	& RV{ }free & OV{ }free & IS{ }free ;

: -PKT
     & P{ }free & XY{ }free & H{ }free & opphav{ }free  ;

: 0pkt ( n -- )  \ nullstill koo NB falske
    0 0 ROT XY{ SWAP } 2! ;       \ data til pkt n

\ n er antal sikt. Inneheld antal nypunkt er opptil 2n
\ antalet er ikkje kjent ennå. 
: +PS ( n -- ) \ lag plass for sikt og pkt
	DUP TO siktmax
	DUP +SIKT
	2*           ( maks antal pktnamn i obslinjene )
	#koolinjer @ ( antal pktnamn i koo-linjenne )
	+            ( mogleg antal pktnamn i alt )
	DUP TO pktmax   \ alltid mindre, pga gjengangarar
	+PKT ;

: @x'y' ( pnr -- x' y' )   \ hent falske koo
	XY{ SWAP } 2@ ;

: !x'y' ( x y pktnr - )    \ xy til nypkt
	XY{ swap } 2! ;
	
: endenr ( snr -- franr tilnr )
   DUP frapkt  SWAP tilpkt ;

: har-koo?   ( pnr -- flag )  \ pkt med koo
	opphav{ SWAP } @   0> ;

: frakoo? ( snr -- flagg )
	frapkt har-koo? ;

: toendekoo? ( snr - flagg )  \ sikt med kjente endepkt?
   DUP ( snr snr )
   frakoo?  ( snr flagg )
   SWAP tilpkt  har-koo?   AND ;

: toendekoo@	( snr -- x1 y1 x2 y2 )
	DUP   frapkt @x'y'  ( snr x1 y1 ) ROT
	( x1 y1 snr )   tilpkt @x'y' ;

: koo-diff ( snr - dx dy )
   toendekoo@  2swap  D-                          \         cr ." dy dx" 2dup . . 
   ;

: hypohypo ( snr -- l*l ) koo-diff hypo2 D>S ;

: x'y'>xy ( x' y' -- x y ) \ internt til eksternt format
	xymin 2@  D+ ;

: @xy ( pnr -- x y ) \ hent ekte koo
	@x'y' ( x' y' )  x'y'>xy ;
	
: @h ( pnr -- h )   \ hent h
	H{ SWAP } @ ;

: toendeh@	( snr -- h1 h2 )
	DUP   frapkt @h  ( snr h1 ) swap
	( h1 snr )   tilpkt @h ;
	
: hdiff ( snr -- dh )
	dup toendeh@ ( snr h1 h2 ) swap -
	IS{ rot } 2@ ( dh i s ) rot + swap - ;
	
: HarRetningsobs? ( snr -- f )
	HVvekt{ swap } @ 0= 0= ( f ) ;
	
: HarLengdeobs? ( snr -- f )
	LS{ over } @ 0> ( snr f )
	VV{ rot } @ 0> and ;
	
: HarVvobs? ( snr -- f )
	VVvekt{ swap } @ 0= 0= ( f ) ;

: HarVertikalobs? ( snr -- f )
	dup HarVvobs? ( snr f ) 
	IS{ rot } 2@ ( f i s ) or and 0= 0= ;

: HarPolarobs? ( snr -- f ) \ nok obs
	dup HarRetningsobs?
	swap HarLengdeobs? and ;

\ : har-lengde?  ( snr - flagg )  \ sikt med lengdeobs?
\   LS{ SWAP } @ 0 > ;

: HarH? ( pnr -- f )
	opphav{ swap } @  ;

: AllePkt   ptal @ 0 ;
: AlleSikt   stal @ 0 ;


